package ida.pelab.loopdistributionTool;


import java.util.ArrayList;
import java.util.Stack;

import cetus.hir.Traversable;

public class TarjanAlgorithm {
	
	private static DirectedGraph   directedGraph;
	
	 private static int[] vertexIndex ,lowLink;
	 private static int index=-1;
	 private static Stack<Traversable> vertexStack;
	 private static  ArrayList<ArrayList<Traversable>> scComponents;
	 private static void setValues(DirectedGraph inputGraph)
	{
		setDirectedGraph(inputGraph);
		ArrayList<Traversable>  vertices= inputGraph.getVertices();
		vertexIndex = new int[vertices.size()];
		lowLink= new int[vertices.size()];
		vertexStack= new Stack<Traversable>();
		scComponents= new  ArrayList<ArrayList<Traversable>>();
		for(int i = 0 ; i< vertexIndex.length;i++)
			vertexIndex[i]=-1;
		for(int i = 0 ; i< lowLink.length;i++)
			lowLink[i]=-1;
							
	}
	
	public static  ArrayList<ArrayList<Traversable>> findStronglyConnectedComponents(DirectedGraph inputGraph)
	{
		
		setValues(inputGraph);
		 setIndex(0);
		
		
		ArrayList<Traversable>  vertices= getDirectedGraph().getVertices();
		for(int i = 0 ; i< vertices.size();i++)
		{
			
			if(isUndefined(i))
				strongConnect(i,vertices.get(i));
			
			
			
		}
		
		return scComponents;
		
	}
	
	private static void  addNewStronglyConnectedComponent( ArrayList<Traversable> input)
	{
		scComponents.add(input);
		
	}
	private static void strongConnect(int vertexID,Traversable vertex)
	{
		vertexIndex[vertexID]=getIndex();
		lowLink[vertexID]=getIndex();
		setIndex(getIndex()+1);
		vertexStack.push(vertex);
		ArrayList<Traversable> successors= getDirectedGraph().getSuccessors(vertex);
		
		for(int i= 0; i<successors.size();i++)
		{
			int vIndex =getDirectedGraph().getVertices().indexOf(successors.get(i));
			if(isUndefined(vIndex))
				{
					strongConnect(vIndex, successors.get(i));
					lowLink[vertexID]= Math.min(lowLink[vertexID], lowLink[vIndex]);
				}
			else if (vertexStack.contains(successors.get(i)))
				{
				   lowLink[vertexID] = Math.min(lowLink[vertexID], vertexIndex[vIndex]);
				}
					
				
		}
		
		 if(lowLink[vertexID] == vertexIndex[vertexID]) 
		 {
			 Traversable w;
			 ArrayList<Traversable>  newComponent =  new ArrayList<Traversable>();
			 do
			 {
				 w =vertexStack.pop();
				 newComponent.add( w);
				 
			 }
			 while(vertex!=w);
			addNewStronglyConnectedComponent(newComponent);
			 
		 }
	     
				
		
		
	}

	
	
	private  static void setDirectedGraph(DirectedGraph drg) {
		directedGraph = drg;
	}

	private  static  DirectedGraph getDirectedGraph() {
		return directedGraph;
	}
	
	
	private static boolean isUndefined(int i)
	{
		return vertexIndex[i]==-1;
	}

	private static void setIndex(int idx) {
		index = idx;
	}

	private static int getIndex() {
		return index;
	}

}
