package ida.pelab.prt.constraints;

import ida.pelab.prt.generalfunctions.LoopDirectionType;
import ida.pelab.prt.generalfunctions.LoopFunctions;
import ida.pelab.prt.pattern.MatchedInstance;
import ida.pelab.prt.transformation.ExpressionSimplifier;

import java.util.ArrayList;


import cetus.hir.ForLoop;
import cetus.hir.Traversable;

public class LoopCheck  extends Constraint{
	
	
private String stepIncrement;
private LoopDirectionType direction;

public LoopCheck(String step,LoopDirectionType dir)
{
  stepIncrement=step;
  direction=dir;
	
	
	
}
@Override
public boolean check(Traversable rootNode,
		ArrayList<MatchedInstance> children) {
	// TODO Auto-generated method stub
	
	if(!(rootNode instanceof ForLoop)|| direction==LoopDirectionType.Unkown)
		return false;
	ForLoop cuLoop =(ForLoop)rootNode;
	return LoopFunctions.detectLoopDirection(cuLoop).equals(direction) && 
	ExpressionSimplifier.Simplify(LoopFunctions.getStepIncrement(cuLoop)).toString().equals(stepIncrement);
			
	
}
public void setStepIncrement(String stepIncrement) {
	this.stepIncrement = stepIncrement;
}
public String getStepIncrement() {
	return stepIncrement;
}
public void setDirection(LoopDirectionType direction) {
	this.direction = direction;
}
public LoopDirectionType getDirection() {
	return direction;
}
}
