package ida.pelab.prt.constraints;


import ida.pelab.prt.generalfunctions.LoopFunctions;
import ida.pelab.prt.generalfunctions.TraverseFunction;
import ida.pelab.prt.pattern.MatchedInstance;
import ida.pelab.prt.pattern.SubscriptedIndexList;
import ida.pelab.prt.pattern.SubscriptedIndexTree;
import ida.pelab.prt.patternrecognitionTool.StructuralComparison;

import java.util.ArrayList;


import cetus.hir.ArrayAccess;
import cetus.hir.Expression;
import cetus.hir.FloatLiteral;
import cetus.hir.ForLoop;
import cetus.hir.Identifier;
import cetus.hir.IntegerLiteral;
import cetus.hir.Traversable;

public class TypeCheck extends Constraint {

	RuleParameterType paramType;
	public TypeCheck(RuleParameterType paramType, String parameter) {
		super();
		this.paramType = paramType;
		this.parameter = parameter;
	}
	public RuleParameterType getParamType() {
		return paramType;
	}
	public void setParamType(RuleParameterType paramType) {
		this.paramType = paramType;
	}
	public String getParameter() {
		return parameter;
	}
	public void setParameter(String parameter) {
		this.parameter = parameter;
	}
	String parameter ;

	
	public boolean isSubscripted(Traversable node,Traversable subTree)
	{
		  if(!(node instanceof ArrayAccess)|| !(subTree instanceof ForLoop))
			   return false;
		    Expression loopVarExp=LoopFunctions.getLoopvariable((ForLoop) subTree);
		    ArrayList<Integer> indicesList= TraverseFunction.findSubscriptedIndices((ArrayAccess)node, loopVarExp);
		     SubscriptedIndexList alreadysubscripted= SubscriptedIndexTree.getIndexList(node);
		     if(alreadysubscripted!=null)
		    	 indicesList.removeAll(alreadysubscripted.getSubscriptedList());
		    
		    if(indicesList.size()!=1)
		    	return false;
		    else 
		      {
		        SubscriptedIndexTree.addCandidateIndex(node, indicesList.get(0));
		        return true;
		       }	    
		    //return TraverseFunction.ExpressionContainsVariable(loopVarExp,node) &&
		    	//	TraverseFunction.hasSimpleIndices(loopVarExp, node);
		
	}
	public boolean check(Traversable rootnode, ArrayList<MatchedInstance> nodelist )
	{
		Traversable node= StructuralComparison.mapParameter(parameter, nodelist);
	   switch (paramType) {
	   
	   case Identifier:
		   return  node instanceof Identifier;
	   case Vector:
		   return node instanceof ArrayAccess;
	   case Number: return node instanceof IntegerLiteral || node instanceof FloatLiteral; 
	   case Subscripted:
		   return isSubscripted (node,rootnode);
	   case nonSubscripted:
		   return ! isSubscripted(node,rootnode);
	   default: return false;
	}
		
	}
	
}

