package ida.pelab.prt.pattern;






import ida.pelab.prt.constraints.RuleParameterType;

import ida.pelab.prt.patternrecognitionTool.StructuralComparison;

import java.util.ArrayList;



import cetus.hir.IfStatement;

import cetus.hir.ForLoop;


import cetus.hir.Traversable;


public class PatternInstance {
	
	private PatternStructure  pattern;
	private ArrayList<PatternInstanceParameter> parameters = new ArrayList<PatternInstanceParameter>();
	
	
	
	public  PatternInstance(PatternStructure pattern)
	{
		setPattern(pattern);
	}
	
	
	public void addParameter(PatternInstanceParameter param)
	{
			parameters.add(param);
	}



	public ArrayList<PatternInstanceParameter> getParameters() {
		return parameters;
	}


	public PatternStructure getPattern() {
		return pattern;
	}



	public void setPattern(PatternStructure patternRef) {
		this.pattern = patternRef;
	}
	
	
	public static PatternInstance ToPatternInstance(Traversable rootNode, PatternStructure pattern, ArrayList<MatchedInstance> subPatterns)
	{
		PatternInstance outputResult= new PatternInstance(pattern);		
		ArrayList<PrintArgument> outputArgs= pattern.getOutputSyntax().getParameters();
		for(int i=0;i< outputArgs.size();i++)
		{
			switch (outputArgs.get(i).getType()) {
			case Extra:
				outputResult.addParameter(new PatternInstanceParameter(outputArgs.get(i).getValue()) );
				break;
			case PatternName:
				{
				     String patternIndx= outputArgs.get(i).getValue();
				     int index= Integer.parseInt(patternIndx);
				     String ptrName=subPatterns.get(index-1).getInstance().getPattern().getOutputSyntax().getPrintingName();
					 outputResult.addParameter(new PatternInstanceParameter(ptrName));
				}
				break;	
			case Condition:
				 if( !(rootNode instanceof IfStatement))
					 break;
				 else
				 {
					 Traversable condExp= ((IfStatement)rootNode).getControlExpression();
					 outputResult.addParameter(new PatternInstanceParameter(condExp,RuleParameterType.Condition));
					 break;
				 }				
			
			case Loopvariable:
				LoopVariable lp =LoopVariable.buildVariable((ForLoop)rootNode);
				outputResult.addParameter(new PatternInstanceParameter(lp,RuleParameterType.Loopvariable));
				break;
			case Parameter:
				PatternInstanceParameter newParam= StructuralComparison.mapParameterInstance(pattern,outputArgs.get(i).getValue(),subPatterns);
				if(i== outputArgs.size()-1)
				{	
					if(pattern.getName().equals("ADD2OP2")|| pattern.getName().equals("AADD5")||pattern.getName().equals("ADDMUL2OP3")||
							pattern.getName().equals("AADDMUL3"))
						newParam.setNegated(true);
					if(pattern.getName().equals("MUL2OP2")||pattern.getName().equals("AMUL5"))
						newParam.setDivided(true);
					
				}
				outputResult.addParameter(newParam);

				break;
			case Allparams:
				outputResult.parameters.addAll(StructuralComparison.mapAllParameterInstance(pattern,outputArgs.get(i).getValue(),subPatterns));
				break;
			default:
				break;
			}
			
			
		}
		
		return outputResult;
		
	}
	
	
	

	
	/*private static String negate(PatternInstanceParameter x)
	{
	    String result= new UnaryExpression(UnaryOperator.MINUS, ((Expression)x.getTreeNode()).clone()).toString();
	     result=result.replaceAll(" ", "");
	     return result.substring(1,result.length()-1);
	}
	private static String  dividebyone(PatternInstanceParameter x)
	{
		
	   return  Symbolic.divide(new IntegerLiteral(1), (Expression)x.getTreeNode()).toString();	
	}*/
	
}
