package ida.pelab.prt.pattern;

import ida.pelab.prt.constraints.RuleParameterType;
import cetus.hir.Traversable;

public class PatternInstanceParameter {
	
	
   public  PatternInstanceParameter(Traversable node)	
   {
	   setTreeNode(node);
		this.negated=false;
		this.divided=false;
	   
   }
   public  PatternInstanceParameter(PatternInstanceParameter copy)	
   {
	   setTreeNode(copy.getTreeNode());
		this.negated=copy.isNegated();
		this.divided=copy.isDivided();
		stringValue=copy.getStringValue();
		type=copy.getType(); 
	   
   }
   public  PatternInstanceParameter(Traversable node,RuleParameterType nodetype)	
   {
	   setTreeNode(node);
	   setType(nodetype);
	   this.negated=false;
	   this.divided=false;
   }
   public PatternInstanceParameter(String value){
	   setStringValue(value);
	   setType(RuleParameterType.String);
   }
   public Traversable getTreeNode() {
	return treeNode;
   }
   public void setTreeNode(Traversable treeNode) {
	   this.treeNode = treeNode;
   }

 
   public void setType(RuleParameterType type) {
	this.type = type;
}
public RuleParameterType getType() {
	return type;
}


public void setStringValue(String stringValue) {
	this.stringValue = stringValue;
}
public String getStringValue() {
	return stringValue;
}

public void setNegated(boolean negated) {
	this.negated = negated;
}
public boolean isNegated() {
	return negated;
}
public void setDivided(boolean divided) {
	this.divided = divided;
}
public boolean isDivided() {
	return divided;
}


	private boolean negated;
	private boolean divided;
	private Traversable  treeNode;
	private RuleParameterType type;
	private String stringValue;

	
}


