package ida.pelab.prt.pattern;




import java.util.Hashtable;



import cetus.hir.Traversable;

public class SubscriptedIndexTree {
	
	
	
	private final static Hashtable<Integer, SubscriptedIndexList>  indexTree= new Hashtable<Integer, SubscriptedIndexList>();
	
	public static SubscriptedIndexList getIndexList(Traversable parentNode)
	{
		if(indexTree.containsKey(System.identityHashCode(parentNode)))
			return  indexTree.get(System.identityHashCode(parentNode));
		else 
			return null;
		
	}
	

	
	
	public static void  addIndex(Traversable node,int index)
	{
	
		if(indexTree.containsKey(System.identityHashCode(node)))
		{
			SubscriptedIndexList  indexList= indexTree.get(System.identityHashCode(node));
			indexList.addSubscriptedIndex(index);		
			
		}
		else 
		{   
			SubscriptedIndexList  indexList= new SubscriptedIndexList();
			indexList.addSubscriptedIndex(index);
			indexTree.put(System.identityHashCode(node), indexList);
		}
		
	}
	
	
	public static void  addCandidateasIndex(Traversable node)
	{
	
		if(indexTree.containsKey(System.identityHashCode(node)))
		{
			SubscriptedIndexList  indexList= indexTree.get(System.identityHashCode(node));
			indexList.addSubscriptedIndex(indexList.getCandidateIndex());		
			
		}

		
	}
	
	
	public static void  addCandidateIndex(Traversable node,int index)
	{
	
		if(indexTree.containsKey(System.identityHashCode(node)))
		{
			SubscriptedIndexList  indexList= indexTree.get(System.identityHashCode(node));
			indexList.setCandidateIndex(index);		
			
		}
		else 
		{   
			SubscriptedIndexList  indexList= new SubscriptedIndexList();
			indexList.setCandidateIndex(index);
			indexTree.put(System.identityHashCode(node), indexList);
		}
		
	}
	
	public static int getCandidateIndex(Traversable node)
	{
		if(indexTree.containsKey(System.identityHashCode(node)))
			return  indexTree.get(System.identityHashCode(node)).getCandidateIndex();
		else return -1;
		
	}
	
	public static void Clear()
	{
		indexTree.clear();	
	}
	
}
