package ida.pelab.prt.patternhandlers;



import java.util.ArrayList;



import ida.pelab.prt.analysis.RecognitionAnalysis;
import ida.pelab.prt.pattern.MatchedInstance;
import ida.pelab.prt.pattern.PatternInstance;
import ida.pelab.prt.pattern.PatternStructure;
import ida.pelab.prt.patternhierarchy.AnnotatedTree;





import cetus.hir.Expression;
import cetus.hir.ExpressionStatement;
import cetus.hir.Statement;
import cetus.hir.Traversable;

public class MappedInstanceHandler {



	
public void handle(PatternStructure detectedPattern, Traversable treeNode, ArrayList<MatchedInstance> subPatterns) {
		
		if(treeNode.getParent()!=null)
		{
			PatternInstance instance= PatternInstance.ToPatternInstance(treeNode, detectedPattern, subPatterns);
			MatchedInstance  newPatternRelation = new MatchedInstance(instance, treeNode);
			if(!AnnotatedTree.isPrunable(treeNode))
			{
				AnnotatedTree.AddDetectedPattern(newPatternRelation,treeNode.getParent());
				  RecognitionAnalysis.updateAnalysisInfo(treeNode, detectedPattern);

			}
		}
		
	}


public static boolean handleHorizontal(PatternStructure detectedPattern, Traversable treeNode, ArrayList<MatchedInstance> subPatterns)
	{
			PatternInstance instance= PatternInstance.ToPatternInstance(treeNode, detectedPattern, subPatterns);
			ExpressionStatement newStatement = new ExpressionStatement(new Expression() {;
			});
			Traversable targetNode= findParent(subPatterns.get(subPatterns.size()-1).getTreeNodeReference());
			int lastNodeIndex= treeNode.getChildren().indexOf(targetNode);
			if(lastNodeIndex>-1)
			{
				treeNode.getChildren().add(lastNodeIndex+1, newStatement);
				newStatement.setParent(treeNode);
				MatchedInstance  newPatternRelation = new MatchedInstance(instance, newStatement);
				AnnotatedTree.AddDetectedPattern(newPatternRelation,newStatement.getParent());
				for(int i=0 ; i< subPatterns.size();i++)
					{	
						AnnotatedTree.deleteChildrenPattern(newStatement.getParent(),subPatterns.get(i).getTreeNodeReference());
						targetNode=findParent( subPatterns.get(i).getTreeNodeReference());
						treeNode.getChildren().remove(targetNode);
					}
				
			return true;
			}
			
		return false;	
	}


 private static Traversable findParent(Traversable node)
 {
		if(!(node instanceof Statement))
			return node.getParent();
		else
			return node;
 }

}
