package ida.pelab.prt.patternrecognitionTool;






import ida.pelab.prt.analysis.RecognitionAnalysis;

import ida.pelab.prt.generalfunctions.IgnoredNodes;
import ida.pelab.prt.generalfunctions.TraverseFunction;
import ida.pelab.prt.transformation.ExpressionTransformation;



import cetus.hir.NullStatement;




import cetus.hir.Traversable;

/**
 *Represents the bottom-up post order algorithm used for the pattern recognition process.
 */
public class RecognitionAlgorithm {
	
	
	public static  void traverse(Traversable node  )
	{
	  try
	    {
		
		   MatchingModule patternMatcher= new MatchingModule();
	       if(isInvalid(node)) return ;
		   //traversing non-leaf nodes
		   if(TraverseFunction.hasChildren(node))
	  	  	{
	  	       if(!IgnoredNodes.isUninteresting((node)))
	  	    	  	for(int i=0 ; i<node.getChildren().size();i++)	
	  					traverse(ExpressionTransformation.simplifyNegativeOperator(node.getChildren().get(i)));				
			    // keeps certain information for analysis purposes
	  		   RecognitionAnalysis.updateNodeInfo(node);
	
			   //applies horizontal pattern recognition
	  		   // the while runs at most twice and only for very few patterns 
	  		  while(	patternMatcher.applyHorizontalRecognition(node)){};
	       }	
		
		  patternMatcher.applyVerticalRecognition(node);
		}
		catch (Exception e) {e.printStackTrace();}
					
	}
	
	
  
	
	
	private static boolean isInvalid(Traversable node)
	{
		return node==null || node instanceof NullStatement;
		
	}
	
	



}
